OBJ

    pst       :   "FullDuplexSerial"
    math      :   "SL32_INTEngine_2"
    i2c       :   "jm_i2c"

CON

  _clkmode      = xtal1 + pll16x
  _clkfreq      = 80_000_000

  datapin  = 0         ' SDA of compass
  clockPin = 1         ' SCL of compass

  WRI       = $1A ' Requests Write operation
  RD       = $1B ' Requests Read operation
  MODE     = $09 ' Mode setting register
  X_LSB    = $00 ' X LSB data output register

VAR

  long x
  long y
  long z

PUB Main

  waitcnt(clkfreq/100_000 + cnt)
  pst.start(31, 30, 0, 9600)
  i2c.setup
  init

  repeat
    read_xyz
    pst.tx(1)
    DEG
    pst.tx(99)

PUB init
  ' Sets compass to continuous output mode

  i2c.start
  i2c.write(WRI)
  i2c.write(MODE)
  i2c.write($11)
  i2c.stop

pub read_xyz | temp[2]

'' Read X, Y, and Z registers

  i2c.start
  i2c.write(WRI)
  i2c.write($00)
  i2c.write($00)
  i2c.start
  i2c.write(RD)
  i2c.rd_block(@temp, 6, i2c#NAK)
  i2c.stop

' update globals

  bytemove(@x, @temp.byte[0], 2)                                ' move x from buffer
  ~~x                                                           ' extend sign
  bytemove(@y, @temp.byte[2], 2)
  ~~y
  bytemove(@z, @temp.byte[4], 2)
  ~~z

PUB DEG | Value

    if  x =< 0
        if azimuth =< 0
           value := AZ_A

        if azimuth > 0
           value := AZ_D

    if x > 0
        if azimuth =< 0
          value := AZ_B

        if azimuth > 0
          value := AZ_C

  value := 1 #> value <# 360

  value := (value + 270) // 360

  PST.dec(Value)
  PST.str(string(11, 13, " X "))
  PST.dec(x)
  PST.str(string(11, 13, " Y "))
  PST.dec(y)
  PST.str(string(11, 13, " Z "))
  PST.dec(z)

PRI Azimuth

  result := math.arctan(y,x)

PRI AZ_A        'NE

               result := || azimuth

PRI AZ_B        'SE

               result := azimuth  + 180

PRI AZ_C        'SW

               result := azimuth  + 180

PRI AZ_D        'NW

               result := - azimuth + 360